"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.within = exports.addTestcafeTestingLibrary = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _testcafe = require("testcafe");

var _domTestingLibrary = require("dom-testing-library");

/* eslint-disable no-eval */

/* eslint-disable no-new-func */
const LIBRARY_UMD_PATH = _path.default.join('./node_modules', 'dom-testing-library/dist/dom-testing-library.umd.js');

const LIBRARY_UMD_CONTENT = _fs.default.readFileSync(LIBRARY_UMD_PATH).toString();

const addTestcafeTestingLibrary = async t => {
  // eslint-disable-next-line
  const inject = (0, _testcafe.ClientFunction)(() => {
    // eslint-disable-next-line no-undef
    window.eval(script);
    window.TestCafeTestingLibrary = {};
  }, {
    dependencies: {
      script: LIBRARY_UMD_CONTENT
    }
  });
  await inject.with({
    boundTestRun: t
  })();
};

exports.addTestcafeTestingLibrary = addTestcafeTestingLibrary;
Object.keys(_domTestingLibrary.queries).forEach(queryName => {
  module.exports[queryName] = (0, _testcafe.Selector)(new Function(`
      return DomTestingLibrary.${queryName}(document.body, ...arguments);
      `));
});

const within = async sel => {
  await (0, _testcafe.ClientFunction)(new Function(` 
    const elem = document.querySelector("${sel}");
    window.TestCafeTestingLibrary["within_${sel}"] = DomTestingLibrary.within(elem);

    `))();
  const container = {};
  Object.keys(_domTestingLibrary.queries).forEach(queryName => {
    container[queryName] = (0, _testcafe.Selector)(new Function(`return window.TestCafeTestingLibrary["within_${sel}"].${queryName}(...arguments)`));
  });
  return container; // const container = {}
  // Object.keys(queries).forEach(queryName => {
  //   container[queryName] = Selector(
  //     new Function(
  //       `return DomTestingLibrary.within(document.querySelector("${sel}")).${queryName}(...arguments)`,
  //     ),
  //   )
  // })
  // return container
};

exports.within = within;